﻿using CommonBehaviors.Actions;
using Styx;
using Styx.TreeSharp;
using Styx.WoWInternals.WoWObjects;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

#region [Method] - Class Redundancy
//using C = KnoxzMonk.Rotation.Conditions;
using HkM = MonkzShaman.Core.Managers.Hotkey_Manager;
using SB = MonkzShaman.Core.Helpers.Spell_Book;
using TM = MonkzShaman.Core.Managers.Talent_Manager;
using U = MonkzShaman.Core.Unit;
using S = MonkzShaman.Core.Spell;
using L = MonkzShaman.Core.Utilities.Log;
using SET = MonkzShaman.Core.Utilities.ShamanSettings;
using C = MonkzShaman.Core.Rotation.Condition;
using Styx.CommonBot;
using Styx.WoWInternals;
#endregion

namespace MonkzShaman.Core.Rotation
{
    class EleRotation
    {
        private static LocalPlayer Me { get { return StyxWoW.Me; } }
        private static WoWUnit currentTarget { get { return StyxWoW.Me.CurrentTarget; } }
        private static WoWSpell lavab = WoWSpell.FromId(SB.lava_burst);
        private static WoWSpell ascen = WoWSpell.FromId(SB.ascendance);
        private static WoWSpell liquid = WoWSpell.FromId(SB.liquid_magma);

        #region [Method] - Combat Buffing
        public static Composite combatBuffing()
        {
            return new PrioritySelector(
                new Decorator(ret => !Me.IsAlive || !Me.GotTarget, new ActionAlwaysSucceed())
                );
        }
        #endregion

        #region [Method] - Precombat Buffing
        public static Composite preCombatBuffing()
        {
            return new PrioritySelector(
                new Decorator(ret => !Me.IsAlive || Me.IsCasting || Me.IsChanneling || Me.Mounted || Me.OnTaxi, new ActionAlwaysSucceed()),
                                S.blindCast(SB.aurals_charges, ret => !U.auraExists(Me, SB.aurals_charges))

                
                );
        }
        #endregion

        #region [Method] - Rotation Selector
        public static Composite rotationSelectorEle()
        {
            return new PrioritySelector(
                new Decorator(ret => !Me.IsAlive || !Me.GotTarget || Me.Mounted, new ActionAlwaysSucceed()),

                new Decorator(ret => U.ascendance || U.auraExists(Me, SB.elemental_mastery) && !Me.IsChanneling, C.useTrinket1()),
                new Decorator(ret => U.ascendance || U.auraExists(Me, SB.elemental_mastery) && !Me.IsChanneling, C.useTrinket2()),
                //# In-combat potion is preferentially linked to Ascendance, unless combat will end shortly
                //actions+=/potion,name=draenic_intellect,if=buff.ascendance.up|target.time_to_die<=30
                //actions+=/berserking,if=!buff.bloodlust.up&!buff.elemental_mastery.up&(set_bonus.tier15_4pc_caster=1|(buff.ascendance.cooldown_remains=0&(dot.flame_shock.remains>buff.ascendance.duration|level<87)))
                S.blindCast(SB.spellBerserking, ret => !U.auraExists(Me, SB.elemental_mastery) && !U.isBloodlusted() && ascen.CooldownTimeLeft.TotalSeconds == 0 && U.flameshock_time_left > 15),
                //actions+=/blood_fury,if=buff.bloodlust.up|buff.ascendance.up|((cooldown.ascendance.remains>10|level<87)&cooldown.fire_elemental_totem.remains>10)
                 S.blindCast(SB.spellBerserking, ret => U.isBloodlusted() || U.auraExists(Me, SB.ascendance)),
                //actions+=/arcane_torrent
                //actions+=/elemental_mastery,if=action.lava_burst.cast_time>=1.2
                S.blindCast(SB.elemental_mastery, ret => SET.Instance.UseTalentCds && currentTarget.IsBoss && U.isUnitValid(currentTarget, 40) && lavab.CastTime >= 1250),
                //actions+=/ancestral_swiftness,if=!buff.ascendance.up
                S.blindCast(SB.ancestral_swiftness, ret => SET.Instance.UseTalentCds && !U.ascendance),
                //actions+=/storm_elemental_totem
                S.blindCast(SB.storm_elemental_totem, ret => currentTarget.IsBoss && U.isUnitValid(currentTarget, 40) && TM.talentStorm_ele && SET.Instance.UseTotems),
                //actions+=/fire_elemental_totem,if=!active
                S.blindCast(SB.fire_elemental_totem, ret => currentTarget.IsBoss && U.isUnitValid(currentTarget, 40) && SET.Instance.UseTotems), // CHECK IF TOTEM IN RANGE
                //actions+=/ascendance,if=active_enemies>1|(dot.flame_shock.remains>buff.ascendance.duration&(target.time_to_die<20|buff.bloodlust.up|time>=60)&cooldown.lava_burst.remains>0)
                S.blindCast(SB.ascendance, ret => currentTarget.IsBoss && U.isUnitValid(currentTarget, 40) && SET.Instance.UseAscendance && U.enemiesInRangeOfTarget(8) > 1 | (U.flameshock_time_left > 15 && (currentTarget.HealthPercent < 15 || lavab.CastTime < 1500 || !U.openerTime) && lavab.CooldownTimeLeft.TotalMilliseconds > 1500)),
                //actions+=/liquid_magma,if=pet.searing_totem.remains>=15|pet.fire_elemental_totem.remains>=15
                S.blindCast(SB.liquid_magma, ret => SET.Instance.UseTalentCds && U.isUnitValid(currentTarget, 40) && U.GetTotemTimeLeft(WoWTotemType.Fire) >= 15),
                //S.blindCast(SB.liquid_magma, ret => true),
                
                
                //# If only one enemy, priority follows the 'single' action list.
                //actions+=/call_action_list,name=single,if=active_enemies=1
                //# On multiple enemies, the priority follows the 'aoe' action list.
                //actions+=/call_action_list,name=aoe,if=active_enemies>1
                new Switch<bool>(ret => U.enemiesInRangeOfTarget(8) <= 2 || !SET.Instance.UseAoe,
                    new SwitchArgument<bool>(true,
                        new PrioritySelector(


                //# Single target action priority list

                //actions.single=unleash_flame,moving=1
                S.dropCast(SB.earthquake, ret => currentTarget, ret => U.isUnitValid(currentTarget, 40) && U.auraExists(Me, SB.auraimproved_chain)),
                S.blindCast(SB.unleash_flame, ret => Me.IsMoving),
                //actions.single+=/spiritwalkers_grace,moving=1,if=buff.ascendance.up
                //actions.single+=/earth_shock,if=buff.lightning_shield.react=buff.lightning_shield.max_stack
                S.Cast(SB.earth_shock, ret => U.isUnitValid(currentTarget, 40) && U.ls_stacks >= 20),
                //actions.single+=/lava_burst,if=dot.flame_shock.remains>cast_time&(buff.ascendance.up|cooldown_react)
                S.Cast(SB.lava_burst, ret => U.isUnitValid(currentTarget, 40) && U.flameshock_time_left > 3),
                new Decorator(ret => Me.IsMoving && U.auraExists(Me, SB.aurasurge) && S.castSpellByLua(SB.lava_burst), new PrioritySelector()),
                //actions.single+=/unleash_flame,if=talent.unleashed_fury.enabled&!buff.ascendance.up
                S.blindCast(SB.unleash_flame, ret => U.isUnitValid(currentTarget, 40) && TM.talentUnleashed_fury && !U.ascendance),
                //actions.single+=/flame_shock,if=dot.flame_shock.remains<=9
                S.Cast(SB.flame_shock, ret => U.isUnitValid(currentTarget, 40) && U.flameshock_time_left <= 9),
                //actions.single+=/earth_shock,if=(set_bonus.tier17_4pc&buff.lightning_shield.react>=15&!buff.lava_surge.up)|(!set_bonus.tier17_4pc&buff.lightning_shield.react>15)
                S.Cast(SB.earth_shock, ret => U.isUnitValid(currentTarget, 40) && ((U.auraExists(Me, 165580) && U.ls_stacks > 12) || (!U.auraExists(Me, 165580) && U.ls_stacks > 15))),
                //actions.single+=/earthquake,if=!talent.unleashed_fury.enabled&((1+stat.spell_haste)*(1+(mastery_value*2%4.5))>=(1.875+(1.25*0.226305)+1.25*(2*0.226305*stat.multistrike_pct%100)))&target.time_to_die>10&buff.elemental_mastery.down&buff.bloodlust.down
                //actions.single+=/earthquake,if=!talent.unleashed_fury.enabled&((1+stat.spell_haste)*(1+(mastery_value*2%4.5))>=1.3*(1.875+(1.25*0.226305)+1.25*(2*0.226305*stat.multistrike_pct%100)))&target.time_to_die>10&(buff.elemental_mastery.up|buff.bloodlust.up)
                //actions.single+=/earthquake,if=!talent.unleashed_fury.enabled&((1+stat.spell_haste)*(1+(mastery_value*2%4.5))>=(1.875+(1.25*0.226305)+1.25*(2*0.226305*stat.multistrike_pct%100)))&target.time_to_die>10&(buff.elemental_mastery.remains>=10|buff.bloodlust.remains>=10)
                //actions.single+=/earthquake,if=talent.unleashed_fury.enabled&((1+stat.spell_haste)*(1+(mastery_value*2%4.5))>=((1.3*1.875)+(1.25*0.226305)+1.25*(2*0.226305*stat.multistrike_pct%100)))&target.time_to_die>10&buff.elemental_mastery.down&buff.bloodlust.down
                //actions.single+=/earthquake,if=talent.unleashed_fury.enabled&((1+stat.spell_haste)*(1+(mastery_value*2%4.5))>=1.3*((1.3*1.875)+(1.25*0.226305)+1.25*(2*0.226305*stat.multistrike_pct%100)))&target.time_to_die>10&(buff.elemental_mastery.up|buff.bloodlust.up)
                //actions.single+=/earthquake,if=talent.unleashed_fury.enabled&((1+stat.spell_haste)*(1+(mastery_value*2%4.5))>=((1.3*1.875)+(1.25*0.226305)+1.25*(2*0.226305*stat.multistrike_pct%100)))&target.time_to_die>10&(buff.elemental_mastery.remains>=10|buff.bloodlust.remains>=10)
                //actions.single+=/elemental_blast
                S.Cast(SB.elemental_blast, ret => U.isUnitValid(currentTarget, 40) && TM.talentElemental_blast),
                 //# After the initial Ascendance, use Flame Shock pre-emptively just before Ascendance to guarantee Flame Shock staying up for the full duration of the Ascendance buff
                //actions.single+=/flame_shock,if=time>60&remains<=buff.ascendance.duration&cooldown.ascendance.remains+buff.ascendance.duration<duration
                S.Cast(SB.flame_shock, ret => U.isUnitValid(currentTarget, 40) && ascen.CooldownTimeLeft.TotalSeconds < 3 && U.flameshock_time_left < 18),
                //# Keep Searing Totem up, unless Fire Elemental Totem is coming off cooldown in the next 20 seconds
                S.Cast(SB.searing_totem, ret => U.isUnitValid(currentTarget, 40) && (U.IsSearingTotemNeeded() || (TM.talentLiquidMagma && SET.Instance.UseTalentCds && U.GetTotem(WoWTotemType.Fire).WoWTotem != WoWTotem.FireElemental && liquid.CooldownTimeLeft.TotalMilliseconds < 1500 && U.GetTotemTimeLeft(WoWTotemType.Fire) < 15))),
                //actions.single+=/searing_totem,if=(!talent.liquid_magma.enabled&!totem.fire.active)|(talent.liquid_magma.enabled&pet.searing_totem.remains<=20&!pet.fire_elemental_totem.active&!buff.liquid_magma.up)
                S.Cast(SB.chain_lightning, ret => SET.Instance.Chain_For_Two && U.isUnitValid(currentTarget, 40) && U.enemiesInRangeOfTarget(8) > 1),
                //actions.single+=/spiritwalkers_grace,moving=1,if=((talent.elemental_blast.enabled&cooldown.elemental_blast.remains=0)|(cooldown.lava_burst.remains=0&!buff.lava_surge.react))
                //actions.single+=/lightning_bolt
                S.Cast(SB.lightning_bolt, ret => U.isUnitValid(currentTarget, 40))
                )),

                new SwitchArgument<bool>(false,
                        new PrioritySelector(
                //# Multi target action priority list

                //actions.aoe=earthquake,cycle_targets=1,if=!ticking&(buff.enhanced_chain_lightning.up|level<=90)&active_enemies>=2
                S.dropCast(SB.earthquake, ret => currentTarget, ret => U.isUnitValid(currentTarget, 40) && U.auraExists(Me, SB.auraimproved_chain)),
                //actions.aoe+=/lava_beam
                S.Cast(SB.lava_beam, ret=> U.isUnitValid(currentTarget, 40)),
                //actions.aoe+=/earth_shock,if=buff.lightning_shield.react=buff.lightning_shield.max_stack
                S.Cast(SB.earth_shock, ret => U.isUnitValid(currentTarget, 40) && U.ls_stacks >= 20),
                //actions.aoe+=/thunderstorm,if=active_enemies>=10
                S.blindCast(SB.thunderstorm, ret => U.enemiesInRangeOfMe(10) >=10),
                //actions.aoe+=/searing_totem,if=(!talent.liquid_magma.enabled&!totem.fire.active)|(talent.liquid_magma.enabled&pet.searing_totem.remains<=20&!pet.fire_elemental_totem.active&!buff.liquid_magma.up)
                //S.Cast(SB.searing_totem, ret => true),
                S.Cast(SB.searing_totem, ret => U.isUnitValid(currentTarget, 40) && (U.IsSearingTotemNeeded() || (TM.talentLiquidMagma && SET.Instance.UseTalentCds && U.GetTotem(WoWTotemType.Fire).WoWTotem != WoWTotem.FireElemental && liquid.CooldownTimeLeft.TotalMilliseconds < 1500 && U.GetTotemTimeLeft(WoWTotemType.Fire) < 15))),
                //actions.aoe+=/chain_lightning,if=active_enemies>=2
                S.Cast(SB.chain_lightning, ret => U.isUnitValid(currentTarget, 40))
                //actions.aoe+=/lightning_bolt


                )



                   
                )
                ));




        }
        #endregion
    }
}