﻿using CommonBehaviors.Actions;
using Styx;
using Styx.CommonBot;
using Styx.TreeSharp;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

#region [Method] - Class Redundancy
using Action = Styx.TreeSharp.Action;
using L = MonkzShaman.Core.Utilities.Log;
using SB = MonkzShaman.Core.Helpers.Spell_Book;
using HKM = MonkzShaman.Core.Managers.Hotkey_Manager;
using U = MonkzShaman.Core.Unit;
using System.Diagnostics;
#endregion

namespace MonkzShaman.Core
{
    static class Spell
    {
        public delegate WoWUnit unitSelectionDelegate(object Context);
        public delegate T Selection<out T>(object Context);
        public static int lastSpellCast;
        private static LocalPlayer Me { get { return StyxWoW.Me; } }
        private static WoWUnit currentTarget { get { return Me.CurrentTarget; } }
        public static int counter = 0;

        #region [Method] - Cast Method
        private static Composite castMethod(this int Spell, unitSelectionDelegate unitSelection, Selection<bool> reqs = null, bool gcdCast = false)
        {
            using (StyxWoW.Memory.TemporaryCacheState(false))
            {
                
                return new Decorator(ret => ((reqs != null && reqs(ret)) || (reqs == null)) && unitSelection != null && unitSelection(ret) != null && SpellManager.CanCast(Spell, unitSelection(ret)),
                    new Action(ret =>
                    {
                        if (SpellManager.Cast(Spell, unitSelection(ret)))
                        {
                            lastSpellCast = Spell;
                            L.combatLog(counter + " Casting: " + WoWSpell.FromId(Spell).Name + " on " + unitSelection(ret).SafeName);
                            counter++;
                            //U.pauseCasting();
                            if (!gcdCast)
                                return RunStatus.Success;
                        }
                        return RunStatus.Failure;
                    }));
            }
        }

        private static Composite castMethod(this int Spell, Selection<bool> reqs = null, bool gcdCast = false)
        {
            using (StyxWoW.Memory.TemporaryCacheState(false))
            {
                return new Decorator(ret => ((reqs != null && reqs(ret)) || (reqs == null)) && SpellManager.CanCast(Spell),
                    new Action(ret =>
                    {
                        if (SpellManager.Cast(Spell))
                        {
                            lastSpellCast = Spell;
                            L.combatLog(counter + "Casting: " + WoWSpell.FromId(Spell).Name);
                            counter++;
                            //U.pauseCasting();
                            if (!gcdCast)
                                return RunStatus.Success;
                        }
                        return RunStatus.Failure;
                    }));
            }
        }

        private static Composite dropMethod(this int Spell, unitSelectionDelegate unitSelection, Selection<bool> reqs = null, bool waitForSpell = false)
        {
            return new Decorator(ret => unitSelection != null && reqs(ret) && SpellManager.CanCast(Spell) && (Me.Location.Distance(unitSelection(ret).Location) <= WoWSpell.FromId(Spell).MaxRange || WoWSpell.FromId(Spell).MaxRange == 0),
                new Sequence(
                    new Action(ret => SpellManager.Cast(Spell)),
                    new DecoratorContinue(ctx => waitForSpell,
                        new WaitContinue(1, ret => Me.CurrentPendingCursorSpell != null && Me.CurrentPendingCursorSpell.Id == Spell, new ActionAlwaysSucceed())),
                        new Action(ret =>
                        {
                            SpellManager.ClickRemoteLocation(unitSelection(ret).Location);
                            lastSpellCast = Spell;
                            //U.pauseCasting();
                            L.combatLog("Casting: " + Spell);
                        })));
        }
        #endregion



        #region [Method] - Cooldown, Charge & PowerReg Detection
        public static double cooldownTimeLeft(this int Spell)
        {
            try
            {
                SpellFindResults Results;
                return SpellManager.FindSpell(Spell, out Results) ? (Results.Override != null ? Results.Override.CooldownTimeLeft.TotalMilliseconds : Results.Original.CooldownTimeLeft.TotalMilliseconds) : 9999;
            }
            catch (Exception xException)
            {
                L.diagnosticLog("Exception in cooldownTimeLeft(): ", xException);
                return 9999;
            }
        }
        public static bool castSpellByLua(this int Spell)
        {
            SpellManager.CastSpellById(Spell);
            Lua.DoString("CastSpellById("+Spell+")");
            L.combatLog("Casting LavaSurge because INSTANT! and moving");
            return true;
        }
        public static int getSpellCharges(this int Spell)
        {
            int result = Lua.GetReturnVal<int>("return GetSpellCharges(" + Spell + ")", 0);
            // L.diagnosticLog("Spellcharges: " + result);
            return result;
        }

        public static int getTimeToCharge(this int Spell)
        {

            int result = Lua.GetReturnVal<int>("return GetSpellCharges(" + Spell + ")", 3);
            //L.diagnosticLog("Time to charge: " + result);
            return result;
        }

        public static float getPowerReg()
        {
            float reg = Lua.GetReturnVal<float>("return GetPowerRegen()", 1);
            //L.diagnosticLog("Active Reg: " + reg );
            return reg;
        }
        #endregion

        #region [Method] - Ground Casting
        public static Composite dropCast(this int Spell, unitSelectionDelegate unitSelection, Selection<bool> reqs = null)
        {
            return dropMethod(Spell, unitSelection, reqs);
        }
        #endregion

        #region [Method] - Non-Target Casting
        public static Composite blindCast(this int Spell, Selection<bool> reqs = null, bool gcdCast = false)
        {

            return castMethod(Spell, reqs, gcdCast);

        }
        #endregion

        #region [Method] - Standard Casting
        public static Composite Buff(this int Spell, Selection<bool> reqs = null, bool gcdCast = false)
        {
            return castMethod(Spell, ret => Me, reqs, gcdCast);
        }

        public static Composite Cast(this int Spell, Selection<bool> reqs = null, bool gcdCast = false)
        {
            return castMethod(Spell, ret => currentTarget, reqs, gcdCast);
        }
        #endregion
    }
}