﻿using Styx;
using Styx.Common;
using Styx.Helpers;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace MonkzShaman.Core.Utilities
{
    class ShamanSettings : Settings
    {
        public static readonly ShamanSettings Instance = new ShamanSettings();
        public static Stopwatch stop;
        public ShamanSettings()
            : base(Path.Combine(string.Format("Settings/MonkzShaman/Monkz-DamagaShaman-Settings-{0}.xml", StyxWoW.Me.Name)))
        {
        }

        [Setting, DefaultValue(false)]
        public bool UseAscendance { get; set; }

        [Setting, DefaultValue(true)]
        public bool UseTotems { get; set; }

        [Setting, DefaultValue(true)]
        public bool UseAoe { get; set; }

        [Setting, DefaultValue(true)]
        public bool Chain_For_Two { get; set; }

        [Setting, DefaultValue(true)]
        public bool UseTalentCds { get; set; }

        [Setting, DefaultValue("C")]
        public string Hotkey_Aoe_Key { get; set; }
        [Setting, DefaultValue("Alt")]
        public string Hotkey_Aoe_Modifier { get; set; }

        [Setting, DefaultValue("Q")]
        public string Hotkey_Ascendance_Key { get; set; }
        [Setting, DefaultValue("Alt")]
        public string Hotkey_Ascendance_Modifier { get; set; }

        [Setting, DefaultValue("E")]
        public string Hotkey_Totems_Key { get; set; }
        [Setting, DefaultValue("Alt")]
        public string Hotkey_Totems_Modifier { get; set; }

        [Setting, DefaultValue("F")]
        public string UseTalentCds_Key { get; set; }
        [Setting, DefaultValue("Alt")]
        public string UseTalentCds_Modifier { get; set; }

        [Setting, DefaultValue("V")]
        public string Chain_For_Two_Key { get; set; }
        [Setting, DefaultValue("Alt")]
        public string Chain_For_Two_Modifier { get; set; }

    }
}
